####################################################
#
# config file for SRM-0.5
#

#
# SRM runtime configurations
#
%CONF = (
	 # debug message level: verbose output if set to 1
	 "DEBUG_LEVEL" => "0",

	 # engine-dependent module script name (current: SRM_Julian.pl only)
	 "ENGINE_MODULE" => "SRM_Julian.pl",
	 # default initial command set file (can be overridden by command line)
	 "SRM_INIT" => "srm.init",

	 # Julian: executable binary (prefix)
	 "JULIAN_BIN_PREFIX" => "./bin/julius",
	 # Julian: module-control port number (default: 5506)
	 "JPORT" => "5506",
	 # Julian: output debug log to this file
	 "LOG_JULIAN" => "temp/julius.log",

	 # Perl module for grammar format converter (XML -> Julian) 
	 "XML2JULGRM" => "xml2julgrm.pl",
	 # temporary grammar file prefix
	 "TMP_GRAMMAR_PREFIX" => "temp/_tmpgrammar",

	 # XSLT executable & stylesheet
	 "XSLT_PROCESSOR" => "org.apache.xalan.xslt.Process",
	 "XSL_STYLE" => "./xml2julgrm.xsl",
	 # Java runtime environment
	 "JAVA_BIN" => "/usr/bin/java",
	 # where Xalan and Xerces exists (from apache project)
	 "CLASSPATH" => "./xalan.jar:./xerces.jar",
	 # XML DTD
	 "XML_DTD" => "xmlsrg-ipa.dtd",
	 # Julian grammar compiler
	 "MKDFA" => "./bin/mkdfa.pl",
	 # output log to these files
	 "LOG_XML2JULGRM" => "temp/xslt.log",
	 "LOG_JULGRM2DFA" => "temp/mkdfa.log"
	 );

#
# Julian system-default prefix
#
%binval  = ("API" => "oss",
	    "GRAPH" => "nbest");

#
# Julian system-default parameters
#
# These will be passed to Julian by default.
# If their command is defined in SRM_Julian.pl, these values can be
# changed by SRM commands.

# Note that these are system default values, and can be overridden by
# site startup commands in "srm.init", or user command.
#
%optval = ("-b" => "600",
	   "-b2" => "40",
	   "-s" => "500",
	   "-m" => "1000",
	   "-lookuprange" => "5",
# 06/02/03 by ri: -looktrellis option enabled by default
	   "-looktrellis" => "ON",
	   "-tmix" => "2",
	   "-n" => "1",
	   "-progout" => "OFF",
	   "-proginterval" => "300",
	   "-walign" => "OFF",
	   "-palign" => "OFF",
	   "-input" => "mic",
	   "-lv" => "1500",
	   "-zmeanframe" => "ON",
	   "-rejectshort" => "600",
# 06/02/03 by ri: kanjicode -> charconv
#	   "-kanji" => "noconv",
	   "-charconv_in" => "default",
	   "-charconv_out" => "noconv",
	   "-outcode" => "WLPSC" # pass2 only
	   );

1;
